Parse string into tree of tokens. 

General architecture
--------------------
I intentionally use Dart native objects for result, so the whole chain of parsers could 
be injected by some extra custom step at runtime.

Basic tokenize
--------------
Split string into words, numbers and other character tokens.

```dart
import 'package:string2tree/string2tree.dart' as s2t;
...
List r = new s2t.Parser("this is a test").result;
```
List r contains 7 Map objects with keys: start, end, type.
```
r
|-- (0,3,65)
|-- (4,4,32)
|-- (5,6,65)
|-- (7,7,32)
|-- (8,8,65)
|-- (9,9,32)
'-- (10,13,65)
```

Apostrophe quotes
-----------------
Make structure from single quoted parts of text

```dart
import 'package:string2tree/string2tree.dart' as s2t;
...
String s = "this is 'a special test' of '' single 'quote'";
List r = new s2t.Parser(s).apostropheQuote(-1).result;
```
List r contains 13 Map objects with keys: start, end, type.
```
r
|-- (0,3,65)
|-- (4,4,32)
|-- (5,6,65)
|-- (7,7,32)
|-- (8,23,-1)
|       |-- (8,8,39)
|       |-- (9,9,65)
|       |-- (10,10,32)
|       |-- (11,17,65)
|       |-- (18,18,32)
|       |-- (19,22,65)
|       '-- (23,23,39)
|-- (24,24,32)
|-- (25,26,65)
|-- (27,27,32)
|-- (28,29,-1)
|       |-- (28,28,39)
|       '-- (29,29,39)
|-- (30,30,32)
|-- (31,36,65)
|-- (37,37,32)
'-- (38,44,-1)
        |-- (38,38,39)
        |-- (39,43,65)
        '-- (44,44,39)
```

