@TestOn("vm")

import "package:test/test.dart";
import "package:string2tree/string2tree.dart" as s2t;
import "package:string2tree/object_dumper.dart";

void main() {
	group("Tokenize -",() {
		setUp(() async {
		});
		tearDown(() async {
		});
		test("few words", () async {
			List r = new s2t.Parser("this is a test").result;
			expect(r.length,7);
			expect(r[0]["start"],0);
			expect(r[0]["end"],3);
			expect(r[0]["type"],65);
			expect(r[1]["start"],4);
			expect(r[1]["end"],4);
			expect(r[1]["type"],32);
			expect(r[2]["start"],5);
			expect(r[2]["end"],6);
			expect(r[2]["type"],65);
			expect(r[3]["start"],7);
			expect(r[3]["end"],7);
			expect(r[3]["type"],32);
			expect(r[4]["start"],8);
			expect(r[4]["end"],8);
			expect(r[4]["type"],65);
			expect(r[5]["start"],9);
			expect(r[5]["end"],9);
			expect(r[5]["type"],32);
			expect(r[6]["start"],10);
			expect(r[6]["end"],13);
			expect(r[6]["type"],65);
		});
		test("few words with capital", () async {
			List r = new s2t.Parser("This IS a tEst").result;
			expect(r.length,7);
			expect(r[0]["start"],0);
			expect(r[0]["end"],3);
			expect(r[0]["type"],65);
			expect(r[6]["start"],10);
			expect(r[6]["end"],13);
			expect(r[6]["type"],65);
		});
		test("number", () async {
			List r = new s2t.Parser("this is 234 test").result;
			expect(r.length,7);
			expect(r[4]["start"],8);
			expect(r[4]["end"],10);
			expect(r[4]["type"],48);
		});
		test("multiple spaces", () async {
			List r = new s2t.Parser("this   is 234 test").result;
			expect(r.length,9);
			expect(r[1]["start"],4);
			expect(r[1]["end"],4);
			expect(r[1]["type"],32);
			expect(r[2]["start"],5);
			expect(r[2]["end"],5);
			expect(r[2]["type"],32);
			expect(r[3]["start"],6);
			expect(r[3]["end"],6);
			expect(r[3]["type"],32);
		});
		test("latin1 extra in ASCII", () async {
			List r = new s2t.Parser("this iás a test").result;
			expect(r.length,7);
			expect(r[2]["start"],5);
			expect(r[2]["end"],7);
			expect(r[2]["type"],65);
		});
		test("single at end", () async {
			List r = new s2t.Parser("this is a test ").result;
			expect(r.length,8);
			expect(r[7]["start"],14);
			expect(r[7]["end"],14);
			expect(r[7]["type"],32);
		});
		test("single2 at end", () async {
			List r = new s2t.Parser("this is a test a").result;
			expect(r.length,9);
			expect(r[8]["start"],15);
			expect(r[8]["end"],15);
			expect(r[8]["type"],65);
		});
	});
}